' RechteAendern.vbs
' Rechte auf ein Verzeichnisses vergeben
' Autor: Sven@SConrad.de
' verwendet: SCRun, ADsSecurity
' ===============================
Option Explicit

' Sicherheitskonstanten definieren
Const FULL_CONTROL			= &H1F01FF
Const INHERITED_ACE              = &H10
Const ACCESS_ALLOWED_ACE_TYPE    = &H0
Const ACCESS_DENIED_ACE_TYPE     = &H1
Const Verzeichnisname="D:\DemoSecurity"
Const Benutzername="Laptop\WilliWinzig"
' Aufruf der Prozedur Perm_Add
RechteHinzufuegen Verzeichnisname,Benutzername,FULL_CONTROL,ACCESS_ALLOWED_ACE_TYPE,INHERITED_ACE


Sub RechteHinzufuegen(pfad, Trustee, Mask, Typ, Flags)
Dim SD
Dim ADSSEC
Dim ACL
Dim ACE
wscript.echo "--- Rechte setzen fr " & Trustee
' --- Instanz erzeugen
Set ADSSEC = CreateObject("ADsSecurity")
' --- Security Descriptor holen
Set SD = ADSSEC.GetSecurityDescriptor(CStr(pfad))
' --- Zugriff auf DACL
Set ACL = SD.DiscretionaryAcl
' --- Neuer ACE
Set ACE = CreateObject("AccessControlEntry")
' --- Werte eintragen
ACE.Trustee = Trustee
ACE.accessmask = Mask
ACE.AceType = Typ
ACE.AceFlags = Flags
' --- ACE anfgen
ACL.AddAce ACE
' --- ACL neu sortieren!
SortiereACL ACL
' --- Neuer SD schreiben
ADSSEC.SetSecurityDescriptor SD
wscript.echo "Recht fr " & Trustee & " eingetragen"
End Sub


Sub SortiereACL(ACL)
' Teile dieser Routine stammen von Microsoft
' Sortiere Access Control List zurckgeben
' -- Konstanten
const ADS_ACEFLAG_INHERITED_ACE            = &h10
const ADS_ACETYPE_ACCESS_ALLOWED           = 0
const ADS_ACETYPE_ACCESS_DENIED            = &h1
const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT    = &h5
const ADS_ACETYPE_ACCESS_DENIED_OBJECT     = &h6
' -- Variablen
Dim Sicherheit
Dim sd, dacl, ace, newAce, newdacl
Dim ImpDenyDacl, ImpDenyObjectDacl, InheritedDacl,ImpAllowDacl,impAllowObjectDacl
' -- Erzeugen der Objekte
Set newdacl = CreateObject("AccessControlList")
Set InheritedDacl = CreateObject("AccessControlList")
Set ImpAllowDacl = CreateObject("AccessControlList")
Set InhAllowDacl = CreateObject("AccessControlList")
Set ImpDenyDacl = CreateObject("AccessControlList")
Set ImpDenyObjectDacl = CreateObject("AccessControlList")
Set impAllowObjectDacl = CreateObject("AccessControlList")

' --- Aufteilung der ACL in mehrere Teil-ACL
For Each ace In ACL
' geerbte ACE
  If ((ace.AceFlags And ADS_ACEFLAG_INHERITED_ACE) = ADS_ACEFLAG_INHERITED_ACE) Then 
    InheritedDacl.AddAce ace
  Else ' nicht geerbte ACR
    Select Case ace.AceType
    Case ADS_ACETYPE_ACCESS_ALLOWED
      ImpAllowDacl.AddAce ace
    Case ADS_ACETYPE_ACCESS_DENIED
      ImpDenyDacl.AddAce ace
    Case ADS_ACETYPE_ACCESS_ALLOWED_OBJECT
      impAllowObjectDacl.AddAce ace
    Case ADS_ACETYPE_ACCESS_DENIED_OBJECT
      ImpDenyObjectDacl.AddAce ace
    Case Else
      Wscript.echo "Fehlerhafte ACE" & Hex(ace.AceType)
    End Select
  End If
Next

' --- Korrekte Anordnung der ACE
' -- Zugriffsverweigerungen fr das Objekt eintragen
For Each ace In ImpDenyDacl
  newdacl.AddAce ace
Next
' -- Zugriffsverweigerung fr Attribut und Unterobjekte eintragen
For Each ace In ImpDenyObjectDacl
  newdacl.AddAce ace
Next
' -- Zugriffserlaubnisse fr das Objekt eintragen
For Each ace In ImpAllowDacl
  newdacl.AddAce ace
Next
' -- Zugriffserlaubnisse fr Attribut und Unterobjekte eintragen
For Each ace In impAllowObjectDacl
  newdacl.AddAce ace
Next
' -- Alle geerbten ACEs eintragen
For Each ace In InheritedDacl
  newdacl.AddAce ace
Next
' --- geordnete ACL zurckgeben
Set ACL = newdacl
End Sub
