' ------------------------------------------
' Skriptname: OUs_AusXmlDateiAnlegen.vbs
' Autor: Dr. Holger Schwichtenberg 2006-2007
' ------------------------------------------
' Dieses Skript erstellt eine OU-Struktur aus einer XML-Datei
' ------------------------------------------
' Verwendet FSO, MSXML, ADSI
' ------------------------------------------

Option Explicit

' Parameter
Const WURZEL = "LDAP://E02/dc=it-visions,dc=local"
Const EINGABEDATEI = "OUStruktur.xml"

' Deklaration der Variablen
Dim Datei, WshShell
Dim XMLDokument
Dim wurzelknoten

' COM-Objekte erstellen
Set WshShell = CreateObject("Wscript.shell")
Set XMLDokument = CreateObject("Msxml2.DOMDocument")

' Pfad zur Eingabedatei
Datei = WshShell.CurrentDirectory & "/" & EINGABEDATEI

' Asynchrones Laden ausschalten
XMLDokument.async = False
' Datei laden
XMLDokument.load(DATEI)
WScript.Echo "Dokument geladen"
' Fehler ?
If XMLDokument.parseError.reason <> "" Then MsgBox XMLDokument.parseError.reason, ,"Fehler"
' Wurzel-Knoten auswhlen
Set wurzelknoten = XMLDokument.selectSingleNode("OUStruktur")
' Durchlauf starten bei Wurzel
ParseXMLDokument 0, wurzelknoten, WURZEL

' === Alle Kind-Knoten durchlaufen
Sub ParseXMLDokument(ByVal ebene,  ByVal wurzelknoten, ByVal ouwurzel)
Dim OUKnoten, neuou
ebene = ebene + 1
For Each OUKnoten In wurzelknoten.Childnodes
	WScript.echo "OU gefunden in XML-Datei: " & Space(ebene) & OUKnoten.getAttribute("Name")
	neuou = OUAnlegen(ouwurzel,OUKnoten.getAttribute("Name"))
	ParseXMLDokument ebene, OUKnoten, neuou ' Rekursion
Next
End Sub

' === OU Anlegen
Function OUAnlegen(Vater,OUName)
Dim Domain, OrgEinheit
' Verweis auf die bestehende OU holen
Set Domain = GetObject(Vater)
' Neue OU anlegen
Set OrgEinheit = Domain.Create("organizationalUnit", "OU=" & OUName)
' Beschreibung setzen
OrgEinheit.Description = "Angelegt mit dem Skript von Holger Schwichtenberg!"
' Werte festschreiben
OrgEinheit.SetInfo
' Ausgabe
WScript.Echo "OU wurde angelegt:" & OrgEinheit.ADsPath
OUAnlegen = OrgEinheit.ADsPath
End Function