' AddComputerToDomain.vbs
' Fgt ein Computerkonto zur Domne hinzu
' Autor: Thomas@Gartner-IT.net
' verwendet: ADSI, WMI, WSHRun
' ===============================

Const JOIN_DOMAIN             = 1
Const ACCT_CREATE             = 2
Const ACCT_DELETE             = 4
Const WIN9X_UPGRADE           = 16
Const DOMAIN_JOIN_IF_JOINED   = 32
Const JOIN_UNSECURE           = 64
Const MACHINE_PASSWORD_PASSED = 128
Const DEFERRED_SPN_SET        = 256
Const INSTALL_INVOCATION      = 262144

Dim objNetwork, objComputer, Computer, Reboot
Dim Domain, User, Password

DomainAdmin = "Administrator"
Password    = "password"
Domain      = "WSL"

Dim Computer
Dim objRootDSE, objContainer, objComputer

Const ADS_UF_PASSWD_NOTREQD            = &h0020
Const ADS_UF_WORKSTATION_TRUST_ACCOUNT = &h1000

' Computernamen ermitteln
Set objNetwork = CreateObject("WScript.Network")
Computer = objNetwork.ComputerName

' Computerkonto erzeugen
Set objRootDSE = GetObject("LDAP://rootDSE")
Set objContainer = GetObject("LDAP://cn=Computers," & _
     objRootDSE.Get("defaultNamingContext"))

Set objComputer = objContainer.Create("Computer", "cn=" & Computer)
objComputer.Put "sAMAccountName", Computer & "$"
objComputer.Put "userAccountControl", _
    ADS_UF_PASSWD_NOTREQD OR ADS_UF_WORKSTATION_TRUST_ACCOUNT
objComputer.SetInfo

' Zur Domne hinzufgen
Set objComputer = _
    GetObject("winmgmts:{impersonationLevel=Impersonate}!\\" & _
        Computer & "\root\cimv2:Win32_ComputerSystem.Name='" & _
        Computer & "'")

ReturnValue = objComputer.JoinDomainOrWorkGroup(Domain, _
    Password, Domain & "\" & DomainAdmin, _
    Null, JOIN_DOMAIN + ACCT_CREATE)
