' GPMC_BackupsAuflisten.VBS
' Auflisten aller Backups eines GPOs in einem bestimmten Verzeichnis
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim gpm
Dim objDOMAIN
Dim GPO


' Parameter setzen
Const DOMAIN = "IT-Objects.net"
Const GPOName = "Default Domain Controllers Policy"
Const DIR = "g:\gpmcbackup"

WScript.Echo "Zugriff auf Domain " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set gpm = CreateObject("GPMgmt.GPM")

' Zugriff auf Domne
Set objDOMAIN = gpm.GetDomain(DOMAIN, "", gpm.GetConstants().UseAnyDC)

Dim BackupDir ' GPMBackupDir
Dim Backupliste ' GPMBackupCollection
Dim Backup
Dim SearchCriteria

Set BackupDir = gpm.GetBackupDir(DIR)

WScript.echo vbCr & "Alle Backups von " & GPOName

Set SearchCriteria = gpm.CreateSearchCriteria()
SearchCriteria.Add gpm.GetConstants().SearchPropertyGPODisplayName, gpm.GetConstants().SearchOpEquals, GPOName
Set Backupliste = BackupDir.SearchBackups(SearchCriteria)


For Each Backup In Backupliste
	WScript.echo Backup.GPOID & ";" & Backup.Comment & ";" & Backup.TimeStamp
Next

WScript.echo vbCr & "Das aktuellste Backup von " & GPOName

Set SearchCriteria = gpm.CreateSearchCriteria()
SearchCriteria.Add gpm.GetConstants().SearchPropertyBackupMostRecent, gpm.GetConstants().SearchOpEquals, True
SearchCriteria.Add gpm.GetConstants().SearchPropertyGPODisplayName, gpm.GetConstants().SearchOpEquals, GPOName
Set Backupliste = BackupDir.SearchBackups(SearchCriteria)

For Each Backup In Backupliste
	WScript.echo Backup.GPOID & ";" & Backup.Comment & ";" & Backup.TimeStamp
Next

