' GPMC_DeleteGPO.VBS
' Lschen eines GPO und seiner Verknpfungen in einer Domain
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim gpm
Dim gpmDomain
Dim GPO

' Zu untersuchende AD-Domain
Const DOMAIN = "IT-Objects.net"
Const GPOGUID = "{8D8383F7-79F3-4B5E-B2F2-B7858C4DA323}" 

WScript.Echo "Zugriff auf Domain " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set gpm = CreateObject("GPMgmt.GPM")
' Zugriff auf Domain
Set gpmDomain = gpm.GetDomain(DOMAIN, "", gpm.GetConstants().UseAnyDC)
' Zugriff auf GPO
Set GPO = gpmDomain.GetGPO(GPOGUID) 


WScript.Echo "GPO " & GPO.DisplayName & " wird endgltig gelscht..."
GPORemoveLinks(GPO)
GPO.Delete()
WScript.echo "Skript erfolgreich beendet!"


' === Entfernen aller Verknpfungen fr eine GPO
Function GPORemoveLinks(GPO)

	Dim objGPMSearchCriteria
	Dim SOMs, SOM
    
    WScript.Echo "Links:"
    	
	' Suchkriterium erzeugen
	Set objGPMSearchCriteria = gpm.CreateSearchCriteria()
	' Suche nach allen verlinkten SOMs	
	objGPMSearchCriteria.Add gpm.GetConstants().SearchPropertySOMLinks, gpm.GetConstants().SearchOpContains, GPO
	' Suche starten
	Set SOMs = gpmDomain.SearchSOMs(objGPMSearchCriteria)
  	
	' Schleife fr alle SOM-Objekte in den Suchergebnissen
	 For Each SOM In SOMs
		WScript.Echo "- Entfernte GPO aus: " & SOM.Path
		RemoveLink SOM, GPO
	 Next

End Function


' === Entfernte eine Verknpfung eines GPOs aus einem SOM
Function RemoveLink(SOM, GPO)

Dim Links, Link
' Zugriff auf GPOLinks
Set Links = SOM.GetGPOLinks()

' Suche des zu entfernenden GPOs
For Each Link In Links
	If Link.GPOID = GPOGUID Then ' Link gefunden -> lschen!
		Link.Delete()
		WScript.Echo "  GPO-Verknpfung " & GPO.DisplayName & " wurde entfernt!"
		Exit For
	End If
Next


End Function


