' GPMC_GPOListe.VBS
' Auflisten aller GPOs und seiner Verknpfungen in einer Domain
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim GPM
Dim Constants
Dim GPMDomain
Dim GPOList
Dim GPMSearchCriteria
Dim GPO

' Zu untersuchende AD-Domain
Const DOMAIN = "IT-Objects.net"

WScript.Echo "Zugriff auf Domain " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set GPM = CreateObject("GPMgmt.GPM")

' Zugriff auf Konstanten
Set Constants = GPM.GetConstants()

' Zugriff auf Domain
Set GPMDomain = GPM.GetDomain(DOMAIN,"", Constants.UseAnyDC)

' Liste alle GPOs (GPMGPOCollection) holen
Set GPOList = GPMDomain.SearchGPOs(Nothing)

WScript.Echo "Anzahl GPO-Objekte: " & GPOList.Count 

' Schleife fr die GPO
For Each GPO In GPOList	
	WScript.echo "-------------------------------------"
	WScript.Echo "Name:" & GPO.DisplayName
	WScript.Echo "ID:" & GPO.ID
	WScript.Echo "Path:" & GPO.Path
	WScript.Echo "ID:" & GPO.ID
	WScript.Echo "Einstellungen fr Benutzer:" & GPO.IsUserEnabled
	WScript.Echo "Einstellungen fr Computer:" & GPO.IsUserEnabled
	WScript.Echo "Erstellungsdatum:"& GPO.CreationTime
	WScript.Echo "Letztes nderungsdatum:" & GPO.ModificationTime
	GPOLinks(GPO)
Next



' === Ausgabe aller SOMs fr eine GPO
Function GPOLinks(GPMGPO)

	Dim objGPMSearchCriteria
	Dim SOMList
	Dim SOM 
    Dim strSOMType
    
    WScript.Echo "Dieses GPO ist verknpft mit:"
    	
	' Suchkriterium erzeugen
	Set objGPMSearchCriteria = GPM.CreateSearchCriteria()
	' Suche nach allen verlinkten SOM	
	objGPMSearchCriteria.Add Constants.SearchPropertySOMLinks, Constants.SearchOpContains, GPMGPO
	' Suche starten
	Set SOMList = GPMDomain.SearchSOMs(objGPMSearchCriteria)
  	
	If SOMList.Count = 0 Then
		WScript.Echo "keine"
	Else

	' Schleife fr alle SOM-Objekte in den Suchergebnissen
	 For Each SOM In SOMList
		Select Case SOM.Type
			Case Constants.SOMSite
			   strSOMType = "Site"
			Case Constants.SOMDomain
			   strSOMType = "Domain"
			Case Constants.SOMOU
			   strSOMType = "OU"
		End Select
		WScript.Echo "- " & SOM.Path & " (" & strSOMType & ") "
	 Next
	End If
End Function



