' GPMC_ZugriffAufEinzelneGPO.vbs
' Auflisten aller GPO zu einem AD-Container
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim gpm
Dim gpmDomain
Dim GPO
Dim Links, Link
Dim objContainer

' Zu untersuchende AD-Domain
Const DOMAIN = "IT-Objects.net"
Const CONTAINER = "OU=Softwareentwicklung,DC=IT-Objects,DC=net"

WScript.Echo "Zugriff auf Domain: " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set gpm = CreateObject("GPMgmt.GPM")

' Zugriff auf Domain
Set gpmDomain = gpm.GetDomain(DOMAIN,"", gpm.GetConstants().UseAnyDC)

' Zugriff auf den Container
Set objContainer = gpmDomain.GetSOM(CONTAINER)

WScript.Echo "Zugriff auf Container: " & objContainer.Path

' Zugriff auf GPOLinks
Set Links = objContainer.GetGPOLinks()

WScript.Echo "Anzahl GPO-Objekte: " & Links.Count 

' Schleife ber alle Links in dem Container
For Each Link In Links	
	Set GPO = gpmDomain.GetGPO(Link.GPOID)
	WScript.echo "-------------------------------------"
	WScript.Echo "GPO-Position: " & Link.SOMLinkOrder
	WScript.Echo "Name:" & GPO.DisplayName
	WScript.Echo "ID:" & GPO.ID
	WScript.Echo "Path:" & GPO.Path
	WScript.Echo "ID:" & GPO.ID
	WScript.Echo "Einstellungen fr Benutzer:" & GPO.IsUserEnabled
	WScript.Echo "Einstellungen fr Computer:" & GPO.IsUserEnabled
	WScript.Echo "Erstellungsdatum:"& GPO.CreationTime
	WScript.Echo "Letztes nderungsdatum:" & GPO.ModificationTime
	GPOLinks(GPO)
Next



' === Ausgabe aller SOM fr eine GPO
Function GPOLinks(GPMGPO)

	Dim objGPMSearchCriteria
	Dim SOMList
	Dim SOM 
    Dim strSOMType
    
    WScript.Echo "Diese GPO ist verknpft mit:"
    	
	' Suchkriterium erzeugen
	Set objGPMSearchCriteria = gpm.CreateSearchCriteria()
	' Suche nach allen verlinkten SOM	
	objGPMSearchCriteria.Add gpm.GetConstants().SearchPropertySOMLinks, gpm.GetConstants().SearchOpContains, GPMGPO
	' Suche starten
	Set SOMList = gpmDomain.SearchSOMs(objGPMSearchCriteria)
  	
	If SOMList.Count = 0 Then
		WScript.Echo "keine"
	Else

	' Schleife fr alle SOM-Objekte in den Suchergebnissen
	 For Each SOM In SOMList
		Select Case SOM.Type
			Case gpm.GetConstants().SOMSite
			   strSOMType = "Site"
			Case gpm.GetConstants().SOMDomain
			   strSOMType = "Domain"
			Case gpm.GetConstants().SOMOU
			   strSOMType = "OU"
		End Select
		WScript.Echo "- " & SOM.Path & " (" & strSOMType & ") "
	 Next
	End If
End Function



