' GPMC_LetzteVersionWiederherstellen.vbs
' Wiederherstellen der letzten gesicherten Version einer GPO
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim GPM ' GPM
Dim DOMAIN ' GPMDomain
Dim GPO ' GPMGPO
Dim BackupDir ' GPMBackupDir
Dim Backupliste ' GPMBackupCollection
Dim Backup ' GPMBackup
Dim SearchCriteria ' GPMSearchCriteria

' Parameter setzen
Const DOMAINSTRING = "IT-Objects.net"
Const GPOName = "Default Domain Controllers Policy"
Const DIR = "g:\gpmcbackup"

WScript.Echo "Zugriff auf Domain " & DOMAINSTRING

' Zugriff auf das Wurzelobjekt
Set GPM = CreateObject("GPMgmt.GPM")


Set BackupDir = GPM.GetBackupDir(DIR)

WScript.echo vbCr & "Das aktuellste Backup von '" & GPOName & "' wird gesucht..." 

Set SearchCriteria = GPM.CreateSearchCriteria()
SearchCriteria.Add GPM.GetConstants().SearchPropertyBackupMostRecent, GPM.GetConstants().SearchOpEquals, True
SearchCriteria.Add GPM.GetConstants().SearchPropertyGPODisplayName, GPM.GetConstants().SearchOpEquals, GPOName
Set Backupliste = BackupDir.SearchBackups(SearchCriteria)

For Each Backup In Backupliste
	WScript.echo "Gefunden: " & Backup.GPOID & ";" & Backup.Comment & ";" & Backup.TimeStamp
	' Zugriff auf Domne
	Set DOMAIN = GPM.GetDomain(DOMAINSTRING, "", GPM.GetConstants().UseAnyDC)
	' Wiederherstellung
	DOMAIN.RestoreGPO Backup,0 
	WScript.echo "GPO wurde wiederhergestellt!"
Next

