' GPMC_LinkGPO.vbs
' Vernpfen eines GPO mit einem AD-Container
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim gpm
Dim gpmDomain
Dim GPO
Dim Links, Link
Dim objContainer

' Zu untersuchende AD-Domain
Const DOMAIN = "IT-Objects.net"
Const CONTAINER = "OU=Softwareentwicklung,DC=IT-Objects,DC=net"
Const GPOGUID = "" ' oder z.B. {152B91EC-72A3-4FD0-B988-046DCA578D17}"
Const GPONAME = "RichtlinieFuerSoftwareentwickler"

WScript.Echo "Zugriff auf Domain: " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set gpm = CreateObject("GPMgmt.GPM")

' Zugriff auf Domain
Set gpmDomain = gpm.GetDomain(DOMAIN,"", gpm.GetConstants().UseAnyDC)

' Zugriff auf den Container
Set objContainer = gpmDomain.GetSOM(CONTAINER)

' Zugriff auf das GPO
If GPOGUID <> "" Then
	Set GPO = gpmDomain.GetGPO (GPOGUID)
Else
	Set GPO = GetGPOByName(GPONAME)
End If

' Verknpfung herstellen
Set Link = objContainer.CreateGPOLink(-1, GPO)

WScript.echo "Die GPO " & GPO.DisplayName & " wurde dem Container " & objContainer.Path	 & " zugewiesen!"


' === Suche eine GPO anhand seines Namens
Function GetGPOByName(Name)
Dim objGPMSearchCriteria
Dim Liste
' Suchkriterium erzeugen
Set objGPMSearchCriteria = gpm.CreateSearchCriteria()
' Suche nach allen verlinkten SOM	
objGPMSearchCriteria.Add gpm.GetConstants().SearchPropertyGPODisplayName, gpm.GetConstants().SearchOpEquals, Name
' Suche ausfhren
Set Liste = gpmDomain.SearchGPOs(objGPMSearchCriteria)
Set GetGPOByName = Liste.item(1)
End Function