' GPMC_RemoveLinkGPO.vbs
' Entfernen einer Verknpfung eines GPOs mit einem AD-Container
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim gpm
Dim gpmDomain
Dim GPO
Dim Links, Link
Dim objContainer

' Zu untersuchende AD-Domain
Const DOMAIN = "IT-Objects.net"
Const CONTAINER = "OU=Softwareentwicklung,DC=IT-Objects,DC=net"
Const GPOGUID = "{152B91EC-72A3-4FD0-B988-046DCA578D17}"

WScript.Echo "Zugriff auf Domain: " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set gpm = CreateObject("GPMgmt.GPM")

' Zugriff auf Domain
Set gpmDomain = gpm.GetDomain(DOMAIN,"", gpm.GetConstants().UseAnyDC)

' Zugriff auf den Container
Set objContainer = gpmDomain.GetSOM(CONTAINER)

WScript.Echo "Zugriff auf Container: " & CONTAINER

' Zugriff auf GPOLinks
Set Links = objContainer.GetGPOLinks()

WScript.echo "GPOs vor dem Lschen:"
' Schleife ber alle Links in dem Container
For Each Link In Links
	Set GPO = gpmDomain.GetGPO(Link.GPOID)
	WScript.Echo "Name:" & GPO.DisplayName
Next

WScript.echo vbCrLf

' Suche des zu entfernenden GPOs
For Each Link In Links
	Set GPO = gpmDomain.GetGPO(Link.GPOID)
	If Link.GPOID = GPOGUID Then ' Link gefunden -> lschen!
		Link.Delete()
		WScript.Echo "GPO-Verknpfung " & GPO.DisplayName & " wurde entfernt!"
		Exit For
	End If
Next

WScript.echo vbCrLf

' Zugriff auf GPOLinks
Set Links = objContainer.GetGPOLinks()

WScript.echo "GPOs nach dem Lschen:"
' Schleife ber alle Links in dem Container
For Each Link In Links
	Set GPO = gpmDomain.GetGPO(Link.GPOID)
	WScript.Echo "Name:" & GPO.DisplayName
Next
