' GPMC_ZugriffAufEinzelnesGPO.VBS
' Auflisten aller GPOs und ihrer Verknpfungen in einer Domain
' Autor: Dr. Holger Schwichtenberg
' verwendet: GPMC Objects
' ===========================================================

Option Explicit

Dim gpm
Dim objDOMAIN
Dim GPO

' Parameter setzen
Const DOMAIN = "IT-Objects.net"
Const GPOGUID = "{6AC1786C-016F-11D2-945F-00C04fB984F9}" ' Default Domain Controllers Policy
Const GPOName = "Default Domain Controllers Policy"

WScript.Echo "Zugriff auf Domain " & DOMAIN

' Zugriff auf das Wurzelobjekt
Set gpm = CreateObject("GPMgmt.GPM")

' Zugriff auf Domne
Set objDOMAIN = gpm.GetDomain(DOMAIN, "", gpm.GetConstants().UseAnyDC)

' ZUgriff auf GPO ber GUID
Set GPO = objDOMAIN.GetGPO(GPOGUID) 
GPOInfo(GPO)

' Zugriff auf GPO ber Name
Set GPO = GetGPOByName(GPOName)
GPOInfo(GPO)

' === Suche eine GPO anhand seines Namens
Function GetGPOByName(Name)
Dim objGPMSearchCriteria
Dim Liste
' Suchkriterium erzeugen
Set objGPMSearchCriteria = gpm.CreateSearchCriteria()
' Suche nach allen verlinkten SOM	
objGPMSearchCriteria.Add gpm.GetConstants().SearchPropertyGPODisplayName, gpm.GetConstants().SearchOpEquals, Name
' Suche ausfhren
Set Liste = objDOMAIN.SearchGPOs(objGPMSearchCriteria)
Set GetGPOByName = Liste.item(1)
End Function

' === Ausgabe von Informationen zu einem GPO
Sub GPOInfo(GPO)
WScript.echo "-------------------------------------"
WScript.Echo "Name:" & GPO.DisplayName
WScript.Echo "ID:" & GPO.ID
WScript.Echo "Path:" & GPO.Path
WScript.Echo "ID:" & GPO.ID
WScript.Echo "Einstellungen fr Benutzer:" & GPO.IsUserEnabled
WScript.Echo "Einstellungen fr Computer:" & GPO.IsComputerEnabled
WScript.Echo "Erstellungsdatum:"& GPO.CreationTime
WScript.Echo "Letztes nderungsdatum:" & GPO.ModificationTime
GPOLinks(GPO)
End Sub

' === Ausgabe aller SOMs fr eine GPO
Sub GPOLinks(GPO)
	Dim objGPMSearchCriteria
	Dim SOMList
	Dim SOM 
    Dim strSOMType
    WScript.Echo "Diese Gruppenrichtlinie wird benutzt in:"
	' Suchkriterium erzeugen
	Set objGPMSearchCriteria = gpm.CreateSearchCriteria()
	' Suche nach allen verlinkten SOMs	
	objGPMSearchCriteria.Add gpm.GetConstants().SearchPropertySOMLinks, gpm.GetConstants().SearchOpContains, GPO
	' Suche starten
	Set SOMList = objDOMAIN.SearchSOMs(objGPMSearchCriteria)
  	
	If SOMList.Count = 0 Then
		WScript.Echo "keine"
	Else

	' Schleife fr alle SOM-Objekte in den Suchergebnissen
	 For Each SOM In SOMList
		Select Case SOM.Type
			Case gpm.GetConstants().SOMSite
			   strSOMType = "Site"
			Case gpm.GetConstants().SOMDomain
			   strSOMType = "Domain"
			Case gpm.GetConstants().SOMOU
			   strSOMType = "OU"
		End Select
		WScript.Echo "- " & SOM.Path & " (" & strSOMType & ") "
	 Next
	End If
End Sub



