' BenutzerAnlegen_Impersonifiziert.vbs
' Erzeugen eines Benutzerkontos im Active Directory 
' unter Nutzung des Impersonfifizierungsmodus von ADSI
' Autor: Dr. Holger Schwichtenberg
' verwendet: ADSI
' ===============================

Option Explicit
' Variablen deklarieren
Dim Container 
Dim Benutzer

' Konstanten definieren
Const NameDesAdmins = "ito\administrator"
Const KennwortDesAdmins = "geheim"
Const NameDesNeuenBenutzers="HarryHirsch"
Const ContainerPfad = "LDAP://Bochum/OU=Teilnehmer,ou=Training,DC=it-objects,DC=net"
Const Flags = 1 ' ADS_SECURE_AUTHENTICATION 

' %%% Bindung an Container mit Impersonifizierung
' Unspezifisches LDAP-Objekt erzeugen
Dim LDAP
Set LDAP = GetObject("LDAP:") ' Namespace
' Container binden
Set Container = LDAP.OpenDSObject(ContainerPfad, NameDesAdmins, KennwortDesAdmins, Flags)

' %%% Bindung an Container ohne Impersonifizierung
' Set Container = GetObject(ContainerPfad)

' Erzeugung des neuen Benutzers
Set Benutzer = Container.Create("user", "CN=" & NameDesNeuenBenutzers)
' Attribute setzen
Benutzer.Put "samAccountName", NameDesNeuenBenutzers
' Festschreiben der Werte
Benutzer.SetInfo
' Konto aktivieren
Benutzer.AccountDisabled = False
' Festschreiben der Werte
Benutzer.SetInfo
' Meldung ausgeben
WScript.Echo "Benutzer " & Benutzer.AdsPath & " angelegt"
