' BenutzerAnlegen_Impersonifiziert_KennwortEinlesen.vbs
' Erzeugen eines Benutzerkontos im Active Directory 
' unter Nutzung des Impersonfifizierungsmodus von ADSI
' und Einlesen des Kennworts fr den zu 
' impersonifizierenden Nutzer von der Kommandozeile
' Autor: Dr. Holger Schwichtenberg
' verwendet: ADSI, ScriptPW-Komponente
' ===============================

Option Explicit
' Variablen deklarieren
Dim Container 
Dim Benutzer
Dim KennwortDesAdmins

' Konstanten definieren
Const NameDesAdmins = "ito\administrator"
Const NameDesNeuenBenutzers="HugoHastig3"
Const ContainerPfad = "LDAP://Bochum/OU=Teilnehmer,ou=Training,DC=it-objects,DC=net"
Const Flags = 1 ' ADS_SECURE_AUTHENTICATION 

WScript.echo "Skript zum Anlegen eines Benutzers"

' Kennwort einlesen
Dim objPW
Set objPW = CreateObject("ScriptPW.Password")
WScript.echo  "Bitte geben Sie das Kennwort ein: (Die eingegebenen Tasten werden nicht angezeigt. Beenden Sie die Eingabe mit RETURN)"
KennwortDesAdmins = objPW.GetPassword()
WScript.echo Chr(13)

' %%% Bindung an Container mit Impersonifizierung
' Unspezifisches LDAP-Objekt erzeugen
Dim LDAP
Set LDAP = GetObject("LDAP:") ' Namespace
' Container binden
Set Container = LDAP.OpenDSObject(ContainerPfad, NameDesAdmins, KennwortDesAdmins, Flags)

' %%% Bindung an Container ohne Impersonifizierung
' Set Container = GetObject(ContainerPfad)

' Erzeugung des neuen Benutzers
Set Benutzer = Container.Create("user", "CN=" & NameDesNeuenBenutzers)
' Attribute setzen
Benutzer.Put "samAccountName", NameDesNeuenBenutzers
' Festschreiben der Werte
Benutzer.SetInfo
' Konto aktivieren
Benutzer.AccountDisabled = False
' Festschreiben der Werte
Benutzer.SetInfo
' Meldung ausgeben
WScript.Echo "Benutzer " & Benutzer.AdsPath & " angelegt"