' Softwareinventar3.ps1
' Das PowerShell-Script inventarisiert die installierte Software
' verwendet: WMI
' ===========================================================


$Hersteller = "*Microsoft*"
$Eingabedateiname = "computernamen.txt" 
$Ausgabedateiname = "Softwareinventar.csv"

# Import der Computernamen
$Computernamen = Get-Content "computernamen.txt" 
$Computernamen | foreach { 
if (Ping($_))
{
 Write-Host "Inventarisiere Software f?r Computer $_ ..."
 # Auslesen der installierten MSI-Pakete auf allen Computern
 $Software = foreach-object { get-wmiobject win32_product -computername $_ } | 
  where { $_.vendor -like $Hersteller } 

 # Export in CSV
 $Software | export-csv "Softwareinventar.csv" -notypeinformation
}
else
{
 Write-Error "Computer nicht erreichbar!"
}
}

# Ping ausf?hren
function Ping
{   
$status = Get-WmiObject Win32_PingStatus -filter "Address='$args[0]'" | select StatusCode 
return $status.Statuscode -eq 0
}





# SIG # Begin signature block
# MIIEMgYJKoZIhvcNAQcCoIIEIzCCBB8CAQExCzAJBgUrDgMCGgUAMGkGCisGAQQB
# gjcCAQSgWzBZMDQGCisGAQQBgjcCAR4wJgIDAQAABBAfzDtgWUsITrck0sYpfvNR
# AgEAAgEAAgEAAgEAAgEAMCEwCQYFKw4DAhoFAAQUS2g9Nw7X5HUt76fby56NIeNE
# I9egggI+MIICOjCCAaegAwIBAgIQzoM38zEb3aBOHs2fDP10EDAJBgUrDgMCHQUA
# MCoxKDAmBgNVBAMTH0lULVZpc2lvbnMgQ2VydGZpa2F0ZSBERU1PIFJvb3QwHhcN
# MDcwNDExMTAzOTEyWhcNMzkxMjMxMjM1OTU5WjAfMR0wGwYDVQQDExRIU2Nod2lj
# aHRlbmJlcmcgREVNTzCBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEAvqyM9/pY
# vV/OioeAUFr3tMMQDDp3n/amOqBUU5tZfEm4q2x1zMxPmBvcslWtwOVZ/BlPHHCW
# TcdVRILhCBz7+nz7kgHH7KB1xvMLjTO+8Q5ikKE8oonSsulqj9imD0B7/SamYlbE
# 6Ys2s0fB8awPRX4zANjOPq5nIbVzRU4aaZECAwEAAaN0MHIwEwYDVR0lBAwwCgYI
# KwYBBQUHAwMwWwYDVR0BBFQwUoAQ7G9CIs1aVPxCIXT71wXah6EsMCoxKDAmBgNV
# BAMTH0lULVZpc2lvbnMgQ2VydGZpa2F0ZSBERU1PIFJvb3SCEFb74Hl29JmURy0l
# ICjbZa8wCQYFKw4DAh0FAAOBgQCEe6kbODPPtSqcCwlQUPRsBD9aY+r2deCqlZ0W
# VqUn8u/eEQYlbhiZWhX2Z9qXuNP6GoKBgUBil0D9li0k/UgURAKeXm6vag8+cocN
# lKOHjrgiGU3JLYShgTM7uEuUl1qxbccUvELApxqNmApVoUoYjwOqt76uJR66djBc
# ZTz7djGCAV4wggFaAgEBMD4wKjEoMCYGA1UEAxMfSVQtVmlzaW9ucyBDZXJ0Zmlr
# YXRlIERFTU8gUm9vdAIQzoM38zEb3aBOHs2fDP10EDAJBgUrDgMCGgUAoHgwGAYK
# KwYBBAGCNwIBDDEKMAigAoAAoQKAADAZBgkqhkiG9w0BCQMxDAYKKwYBBAGCNwIB
# BDAcBgorBgEEAYI3AgELMQ4wDAYKKwYBBAGCNwIBFTAjBgkqhkiG9w0BCQQxFgQU
# tmfRsOhU57BBqwrm0XbmmscSaxUwDQYJKoZIhvcNAQEBBQAEgYC5/iil461ELNWt
# /iiNRjUk3lNtaq3oeSGlpHemrz1KhViCEoiCJPmALnheuds2xDNi4PbXwnRM3u5A
# hT3IanadrnGnmWm2nCVnAecEkcNTj4NKShBPPsiXJT2KjV2zHYi4Ri2BLXxy1sTk
# kK+xnP9DQaqpehoFUINj4jVgD1cBIQ==
# SIG # End signature block
