

########################################
# Das PowerShell-Script inventarisiert die installierte Software 
# eines Herstellers auf n Computersystemen
# (C) Dr. Holger Schwichtenberg
########################################

$Hersteller = "*Microsoft*"
$Eingabedateiname = "computernamen.txt" 
$Ausgabedateiname = "Softwareinventar.csv"

# Import der Computernamen
$Computernamen = Get-Content "computernamen.txt" 
$Computernamen | foreach { 
if (Ping($_))
{
 Write-Host "Inventarisiere Software f?r Computer $_ ..."
 # Auslesen der installierten MSI-Pakete auf allen Computern
 $Software = foreach-object { get-wmiobject win32_product -computername $_ } | 
  where { $_.vendor -like $Hersteller } 

 # Export in CSV
 $Software | export-csv "Softwareinventar.csv" -notypeinformation
}
else
{
 Write-Error "Computer nicht erreichbar!"
}
}

# Ping ausf?hren
function Ping
{   
$status = Get-WmiObject Win32_PingStatus -filter "Address='$args[0]'" | select StatusCode 
return $status.Statuscode -eq 0
}




